#!/bin/bash

#### INFOS ####
##Name: Cover Thumnailer
##Version: 0.0.1
##Need: bash, php_cli, convert, composite
##Description: Modifie l'icone des dossiers contenant des fichiers cover,...
#### /INFOS ####


#=============================================================== CONFIG ====
thumnail_path="$HOME/.thumbnails/normal/"
thumnail_size="96"

music_path="$HOME/Musique"
video_path="$HOME/Vidéos"

script_path="`echo "$0" | sed -r -e 's#^(.*)/.*\.sh$#\1#'`"
if [ "`echo $script_path | grep '^\..*'`" != "" ] ; then {
	curdir=`pwd`
	script_path=`echo "$script_path"  | sed -r -e "s#^\.#$curdir#"`
} fi
	

#===========================================================================
url_encode() {
	#$1 : URI
	file=`echo -n "$1" | sed -e "s/'/---apos27---/g"`
	php -r "echo urlencode('$file');" | sed -e "s/+/%20/g" \
		-e "s/---apos27---/'/g" \
		-e "s/%28/(/g" \
		-e "s/%29/)/g" \
		-e "s/%2C/,/g" \
		-e "s/%2B/+/g" \
		-e "s#%2F#/#g" \
		-e "s#^/#file:///#"
}

url_decode() {
	#$1 : URI
	php -r "echo urldecode('$1');" | sed "s#file://##"
}

create_thumbnail() {
	#$1 : File path
	#$2 : destination
	#$3 : Logo
	convert "$1" \
		-resize "x$(($thumnail_size*2))" -resize "$(($thumnail_size*2))x<" -resize "50%" \
		-gravity "center" \
		-crop "${thumnail_size}x$thumnail_size+0+0" +repage \
		-extent "${thumnail_size}x$thumnail_size" \
		"$2"
	composite -gravity "SouthWest" \
		-compose "Over" "$3" "$2" "$2"
}

run() {
	#$1 : Path
	#$2 : Default picture
	#$3 : Logo
	path_list="`find -L $1 -type d`"
	i=1
	numbOfLines=`echo "$path_list" | wc -l`
	path="none"
	while [ $i -le $numbOfLines ] ; do {
		path=`echo "$path_list" | head -n $i | tail -n 1`
		
		if [ "$path" != "$music_path" ] && [ "$path" != "$video_path" ] ; then {
			if [ -f "$path/cover.png" ] ; then file_name="cover.png"
			elif [ -f "$path/Cover.png" ] ; then file_name="Cover.png"
			elif [ -f "$path/cover.jpg" ] ; then file_name="cover.jpg"
			elif [ -f "$path/Cover.jpg" ] ; then file_name="Cover.jpg"
			elif [ -f "$path/folder.png" ] ; then file_name="folder.png"
			elif [ -f "$path/Folder.png" ] ; then file_name="Folder.png"
			elif [ -f "$path/folder.jpg" ] ; then file_name="folder.jpg"
			elif [ -f "$path/Folder.jpg" ] ; then file_name="Folder.jpg"
			elif [ -f "$path/.cover.png" ] ; then file_name=".cover.png"
			elif [ -f "$path/.Cover.png" ] ; then file_name=".Cover.png"
			elif [ -f "$path/.cover.jpg" ] ; then file_name=".cover.jpg"
			elif [ -f "$path/.Cover.jpg" ] ; then file_name=".Cover.jpg"
			elif [ -f "$path/.folder.png" ] ; then file_name=".folder.png"
			elif [ -f "$path/.Folder.png" ] ; then file_name=".Folder.png"
			elif [ -f "$path/.folder.jpg" ] ; then file_name=".folder.jpg"
			elif [ -f "$path/.Folder.jpg" ] ; then file_name=".Folder.jpg"
			else file_name=""
			fi

			thumbnail_name="$thumnail_path`url_encode "$path" | md5sum | sed -e 's/  -//'`.png"

			if [ "$file_name" != "" ] ; then {
				create_thumbnail "$path/$file_name" "$thumbnail_name" "$3"
				echo -n "▉"
			} else {
				create_thumbnail "$2" "$thumbnail_name" "$3"
				echo -n "░"
			} fi
		} fi

		i=$(($i+1))
	} done
}

#================================================================= MAIN ====

cd "$HOME"

echo "Music"
run "$music_path" "$script_path/music_nocover.png" "$script_path/music.png"
echo -e "\nVideo"
run "$video_path" "$script_path/video_nocover.png" "$script_path/video.png"

echo

exit 0


